#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,q,c,L,R;
    cin>>n>>q;
    for(int i=1;i<=n;i++) cin>>c;
    for(int i=1;i<=q;i++){
        cin>>c>>L>>R;
        if(L%2==1) L++;
        if(R%2==1) R--;
        if(L>R) cout<<"0\n";
        else cout<<R-L+1<<"\n";
    }
}
